import os
from Products.CMFCore.utils import UniqueObject, getToolByName
from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo, Unauthorized
from Products.CMFPlone.PloneBaseTool import PloneBaseTool
from Products.PageTemplates.PageTemplateFile import PageTemplateFile


# CMF imports
#from Products.CMFCore import CMFCorePermissions


_www = os.path.join(os.path.dirname(__file__), 'www')

class HTMLProxyTool(UniqueObject, SimpleItem, PropertyManager): 
    """
    Tool for HTMLProxy objects
    """
    id = 'htmlproxy_tool'
    meta_type= 'HTMLProxy tool'
    plone_tool = 1
        
    manage_options = PropertyManager.manage_options
    
    security = ClassSecurityInfo()

    manage_options=(
      (
      { 'label' : 'Overview'
      , 'action' : 'manage_overview'
      },
      { 'label' : 'Properties'
      , 'action' : 'manage_propertiesForm'
      },
      )
      )
#        ) +
#        ActionProviderBase.manage_options +
#        SimpleItem.manage_options
#        )

#    security.declareProtected(CMFCorePermissions.ManagePortal, 'manage_overview')
    manage_overview = PageTemplateFile('manage_overview', _www)


    def __init__(self):
      self.manage_addProperty('AccessibleSites', '', 'lines')
      self.manage_addProperty('UseHTTPProxy', 0, 'boolean')
      self.manage_addProperty('HTTPProxy', '', 'string')
      self.manage_addProperty('NoHTTPProxyFor', '', 'string')

    def getAccessibleSites(self):
      return self.AccessibleSites

    def getUseHTTPProxy(self):
      return self.UseHTTPProxy

    def getHTTPProxy(self):
      return self.HTTPProxy

    def getNoHTTPProxyFor(self):
      return self.NoHTTPProxyFor

InitializeClass(HTMLProxyTool)
