# -*- coding: utf-8 -*-
#
# PWURLopener: FancyURLopener with Auth
#                  HTMLProxy System
from AccessControl import ClassSecurityInfo
from urllib import FancyURLopener
import Globals
import urlparse
import socket
import re
import string
import csv
from zLOG import LOG,INFO
from Products.HTMLProxy.auth import *
from Products.HTMLProxy.config import *

class PWURLopener(FancyURLopener):
    # Standard security settings
    security = ClassSecurityInfo()

    # Add User-Agent header
    security.declarePrivate('__init__')
    def __init__(self, agent=None, *args, **kwargs):
      if agent:
        self.version = agent 
      self.accessible = None
      FancyURLopener.__init__(self, *args, **kwargs)

    # Fetch Authentication Data
    security.declarePrivate('prompt_user_passwd')
    def prompt_user_passwd(self, host, realm):
      return authinfo(host, realm)

    security.declarePrivate('open')
    def open(self, fullurl, data=None):
      """ Access check """
      if self.ac_check(self.accessible, fullurl):
        return FancyURLopener.open(self, fullurl, data)
      else:
        raise 'notaccessible'

    security.declarePrivate('ac_check')
    def ac_check(self, accessible, fullurl):
      """ This method judges right or wrong of the access """
      if not accessible:
        return 0

      def ac_check_internal(accessible, fullurl):
        host = re.sub(r'^.*@', '', urlparse.urlparse(fullurl)[1])
        host = re.sub(r':.*$', '', host)
        host_addr = socket.gethostbyname(host)
        el = re.split('\.', host_addr)
        host_addr = string.atoi(el[0]) * 256**3 + string.atoi(el[1]) * 256**2 + string.atoi(el[2]) * 256 + string.atoi(el[3])
        for a in accessible:
          a = a.lstrip().rstrip()
          # list : IP Address
          if re.match('\d+\.\d+\.\d+\.\d+(/\d+)?$', a):
            el = re.split('[\./]', a)
            addr = string.atoi(el[0]) * 256**3 + string.atoi(el[1]) * 256**2 + string.atoi(el[2]) * 256 + string.atoi(el[3])
            if len(el) > 4:
              mask = string.atoi(el[4])
              if mask > 32:
                mask = 32
            else:
              mask = 32
            shift = 32 - mask
            if host_addr >> shift == addr >> shift:
              return 1
          # list : Name
          else:
            a = re.sub(r'([\[\]\(\)\^\$\.\+\?\\])', r'\\\1', a)
            a = re.sub(r'\*', r'.*', a)
            if re.match(r'^' + a + r'$', host):
              return 1
        return 0

      for ac in accessible:
        if not ac_check_internal(ac, fullurl):
          return 0
      return 1

Globals.InitializeClass(PWURLopener)
